Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.jstacs.motifDiscovery
Interface MotifDiscoverer

All Superinterfaces:
  Cloneable, Storable

All Known Subinterfaces:
  MutableMotifDiscoverer

All Known Implementing Classes:
  ExtendedZOOPSDiffSM, HiddenMotifMixture, IndependentProductDiffSM, MappingDiffSM, MixtureDiffSM, VariableLengthMixtureDiffSM, ZOOPSTrainSM

    public interface MotifDiscoverer

extends Cloneable, Storable

This is the interface that any tool for de-novo motif discovery should implement.

Author:
  Jan Grau, Jens Keilwagen

Nested Class Summary
`static class` | `MotifDiscoverer.KindOfProfile` This `enum` can be used to determine which kind of profile should be returned.

Method Summary
`MotifDiscoverer` | `clone()` This method returns a deep clone of the instance.
`int` | `getGlobalIndexOfMotifInComponent(int component, int motif)` Returns the global index of the `motif` used in `component`.
`int` | `getIndexOfMaximalComponentFor(Sequence sequence)` Returns the index of the component with the maximal score for the sequence `sequence`.
`int` | `getMotifLength(int motif)` This method returns the length of the motif with index `motif` .
`int` | `getNumberOfComponents()` Returns the number of components in this `MotifDiscoverer`.
`int` | `getNumberOfMotifs()` Returns the number of motifs for this `MotifDiscoverer`.
`int` | `getNumberOfMotifsInComponent(int component)` Returns the number of motifs that are used in the component `component` of this `MotifDiscoverer`.
`double[]` | `getProfileOfScoresFor(int component, int motif, Sequence sequence, int startpos, MotifDiscoverer.KindOfProfile kind)` Returns the profile of the scores for component `component` and motif `motif` at all possible start positions of the motif in the sequence `sequence` beginning at `startpos`.
`double[]` | `getStrandProbabilitiesFor(int component, int motif, Sequence sequence, int startpos)` This method returns the probabilities of the strand orientations for a given subsequence if it is considered as site of the motif model in a specific component.

Methods inherited from interface de.jstacs.Storable
`toXML`

Method Detail

### clone

    MotifDiscoverer clone()
                          throws CloneNotSupportedException

  This method returns a deep clone of the instance.

  Returns:
    a deep clone of the instance
  Throws:
    `CloneNotSupportedException` - if the instance could not be cloned
  See Also:
    `Cloneable`

### getMotifLength

    int getMotifLength(int motif)

  This method returns the length of the motif with index `motif` .

  Parameters:
    `motif` - the index of the motif
  Returns:
    the length of the motif with index `motif`

### getNumberOfComponents

    int getNumberOfComponents()

  Returns the number of components in this `MotifDiscoverer`.

  Returns:
    the number of components

### getNumberOfMotifs

    int getNumberOfMotifs()

  Returns the number of motifs for this `MotifDiscoverer`.

  Returns:
    the number of motifs

### getNumberOfMotifsInComponent

    int getNumberOfMotifsInComponent(int component)

  Returns the number of motifs that are used in the component `component` of this `MotifDiscoverer`.

  Parameters:
    `component` - the component of the `MotifDiscoverer`
  Returns:
    the number of motifs

### getIndexOfMaximalComponentFor

    int getIndexOfMaximalComponentFor(Sequence sequence)
                                      throws Exception

  Returns the index of the component with the maximal score for the sequence `sequence`.

  Parameters:
    `sequence` - the given sequence
  Returns:
    the index of the component with the maximal score for the given sequence
  Throws:
    `Exception` - if the index could not be computed for any reasons

### getGlobalIndexOfMotifInComponent

    int getGlobalIndexOfMotifInComponent(int component,
                                         int motif)

  Returns the global index of the `motif` used in `component`. The index returned must be at least 0 and less than `getNumberOfMotifs()`.

  Parameters:
    `component` - the component index
    `motif` - the motif index in the component
  Returns:
    the global index of the `motif`in `component```

### getProfileOfScoresFor

    double[] getProfileOfScoresFor(int component,
                                   int motif,
                                   Sequence sequence,
                                   int startpos,
                                   MotifDiscoverer.KindOfProfile kind)
                                   throws Exception

  Returns the profile of the scores for component `component` and motif `motif` at all possible start positions of the motif in the sequence `sequence` beginning at `startpos`. This array should be of length
  `sequence.length() - startpos - motifs[motif].length() + 1`.
  A high score should encode for a probable start position.

  Parameters:
    `component` - the component index
    `motif` - the index of the motif in the component
    `sequence` - the given sequence
    `startpos` - the start position in the sequence
    `kind` - indicates the kind of profile
  Returns:
    the profile of scores
  Throws:
    `Exception` - if the score could not be computed for any reasons

### getStrandProbabilitiesFor

    double[] getStrandProbabilitiesFor(int component,
                                       int motif,
                                       Sequence sequence,
                                       int startpos)
                                       throws Exception

  This method returns the probabilities of the strand orientations for a given subsequence if it is considered as site of the motif model in a specific component.

  Parameters:
    `component` - the component index
    `motif` - the index of the motif in the component
    `sequence` - the given sequence
    `startpos` - the start position in the sequence
  Returns:
    the probabilities of the strand orientations
  Throws:
    `Exception` - if the strand could not be computed for any reasons

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD